<?php
require_once "../../../maincore.php";
require_once THEME."/theme.php";
global $locale;
include_once INFUSIONS."arcade/inc/functions.php";
include_once INFUSIONS."arcade/inc/function.inc.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(ARCADE_LANG.$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include ARCADE_LANG.$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include ARCADE_LANG."English.php";
}


//-----------------------------------------------------------------------------
// SWF HEADER - version 1.0
// Small utility class to determine basic data from a SWF file header
// Does not need any php-flash extension, based on raw binary data reading
//-----------------------------------------------------------------------------
// SWFHEADER CLASS - PHP SWF header parser
// Copyright (C) 2004 Carlos Falo Hervs
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//-----------------------------------------------------------------------------

class swfheader {

var $size ; // Uncompressed file size (in bytes)
var $width ; // Flash movie native width
var $height ; // Flash movie native height
var $valid ; // Valid SWF file


//---------------------------------------------------------------------------
// swfheader($debug) : Constructor, basically does nothing but initilize
// debug and data fields
//---------------------------------------------------------------------------
function swfheader($debug = false) {
$this->debug = $debug ;
$this->init() ;
}

//---------------------------------------------------------------------------
// init() : initialize the data fields to "empty" values
//---------------------------------------------------------------------------
function init() {
$this->width = 0 ;
$this->height = 0 ;
$this->size = 0 ;
$this->fps[] = Array() ;
//if ($this->debug) echo "DEBUG: Data values initialized<br>" ;
}

//---------------------------------------------------------------------------
// loadswf($filename) : loads $filename and stores data from it's header
//---------------------------------------------------------------------------
function loadswf($filename) {
$this->fname = $filename ;
$fp = @fopen($filename,"rb") ;
if ($fp) {
// Read MAGIC FIELD
$this->magic = fread($fp,3) ;
if ($this->magic!="FWS" && $this->magic!="CWS") {
$this->valid = 0 ;
} else {
// Compression
if (substr($this->magic,0,1)=="C") $this->compressed = true ;
else $this->compressed = false ;
// Version
$this->version = ord(fread($fp,1)) ;
// Size
$lg = 0 ;
// 4 LSB-MSB
for ($i=0;$i<4;$i++) {
$t = ord(fread($fp,1)) ;
$lg += ($t<<(8*$i)) ;
}
$this->size = $lg ;
// RECT... we will "simulate" a stream from now on... read remaining file
$buffer = fread($fp,$this->size) ;
if ($this->compressed) {
// First decompress GZ stream
$buffer = gzuncompress($buffer,$this->size) ;
}
$b = ord(substr($buffer,0,1)) ;
$buffer = substr($buffer,1) ;
$cbyte = $b ;
$bits = $b>>3 ;
$cval = "" ;
// Current byte
$cbyte &= 7 ;
$cbyte<<= 5 ;
// Current bit (first byte starts off already shifted)
$cbit = 2 ;
// Must get all 4 values in the RECT
for ($vals=0;$vals<4;$vals++) {
$bitcount = 0 ;
while ($bitcount<$bits) {
if ($cbyte&128) {
$cval .= "1" ;
} else {
$cval.="0" ;
}
$cbyte<<=1 ;
$cbyte &= 255 ;
$cbit-- ;
$bitcount++ ;
// We will be needing a new byte if we run out of bits
if ($cbit<0) {
$cbyte = ord(substr($buffer,0,1)) ;
$buffer = substr($buffer,1) ;
$cbit = 7 ;
}
}
// O.k. full value stored... calculate
$c = 1 ;
$val = 0 ;
// Reverse string to allow for SUM(2^n*$atom)
$tval = strrev($cval) ;
for ($n=0;$n<strlen($tval);$n++) {
$atom = substr($tval,$n,1) ;
if ($atom=="1") $val+=$c ;
// 2^n
$c*=2 ;
}
// TWIPS to PIXELS
$val/=20 ;
switch ($vals) {
case 0:
// tmp value
$this->width = $val ;
break ;
case 1:
$this->width = $val - $this->width ;
break ;
case 2:
// tmp value
$this->height = $val ;
break ;
case 3:
$this->height = $val - $this->height ;
break ;
}
$cval = "" ;
}

fclose($fp) ;
$this->valid = 1 ;
}
} else {
$this->valid = 0 ;
}
return $this->valid ;
}

//---------------------------------------------------------------------------
// show() : report to screen all the header info
//---------------------------------------------------------------------------
function show() {
global $locale;
if ($this->valid) {

// Size
echo "<b>".$locale[ARC078].":</b> " . $this->size . " bytes <br>" ;
// FRAMESIZE
echo "<b>".$locale[ARC076].":</B> " . $this->width . "<br>";
echo "<b>".$locale[ARC077].":</B> " . $this->height . "<br>" ;

} else {
if (file_exists($this->fname))
echo $this->fname . "is not a valid SWF file<br>" ;
else
if ($this->fname=="")
echo "SWFHEADER->SHOW : No file loaded<br>" ;
else
echo "SWFHEDAR->SHOW : " . $this->fname . "was not found<br>" ;
}
}

}


?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<head>
	<title>Game Analizer</title>
	<link rel='stylesheet' href='<?=THEME?>styles.css' type='text/css'>
</head>

<body>
<?php
if ($action=='load'||$action==''||!$action)
{
opentable($locale[ARC074]);
echo '<form action="'.RETURN_SELF.'" method="post">';
buildFlashBox('1','',"flash",'');
echo '<input type="hidden" name="action" value="test">
<input type="submit">
</form>';
closetable();
}
else
{
opentable($locale[ARC075]);
$file = ARCADE_FLASH.$_POST[flash];
// Create a new SWF header object with debug info, open with
// disabled debug (false) for silent processing
$swf = new swfheader(true) ;
// Open the swf file...
// Replace filename accordingly to your test environment...
$swf->loadswf($file) ;
// Show data as a block... you can also access data within the object
$swf->show() ;
closetable();
}

?>
</body>
</html>
